#
# Unit Allegiance Mod
# CvCustomEventManager
# 

from CvPythonExtensions import *
import CvUtil
import sys

import CvEventManager
import CvConfigParser

import JUtils
import CvJDataStorageUtils

######################################

# CvJDataStorageUtils.initTypesDict(pUnit, dictInit=None)
# CvJDataStorageUtils.initTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.hasTypesDict(pUnit)
# CvJDataStorageUtils.hasTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.hasTypeStat(pUnit, xType, xStat)
# CvJDataStorageUtils.setTypeStatsDict(pUnit, xType, dictStats=None)
# CvJDataStorageUtils.setTypeStat(pUnit, xType, xStat, xStatValue=None)
# CvJDataStorageUtils.delTypesDict(pUnit)
# CvJDataStorageUtils.delTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.delTypeStat(pUnit, xType, xStat)
# CvJDataStorageUtils.getDataIDStr(pObj=None)
# CvJDataStorageUtils.getUnitStatsStrType_StrStatList(pUnit, strDelim="_", bStatsTypeFirst=True)
# CvJDataStorageUtils.getTypesDict(pUnit)
# CvJDataStorageUtils.getTypeStatsDict(pUnit, xType)
# CvJDataStorageUtils.getTypeStat(pUnit, xType, xStat)

# JDataStorageUtils.initGlobalDict()
# JDataStorageUtils.hasGlobalDict()
# JDataStorageUtils.hasGlobalData(xKey)
# JDataStorageUtils.setGlobalData(xKey, xValue)
# JDataStorageUtils.getGlobalData(xKey=None)

###################################################
# globals

gc = CyGlobalContext()

#def loadConfigurationFeaturesEnabledData():

        #global g_bUnitAllegianceFeaturesEnabled

        #config = CvConfigParser.CvConfigParser("Unit Allegiance Mod Config.ini")

	#if (config != None):
		#g_bUnitAllegianceFeaturesEnabled = config.getboolean("Unit Allegiance Mod", "Unit Allegiance Features Enabled", True)

###################################################


class CvJDataKitEventManager:
	def __init__(self, eventManager):

		#eventManager.addEventHandler("windowActivation", self.onWindowActivation)
		#eventManager.addEventHandler("unitMove", self.onUnitMove)
		eventManager.addEventHandler("unitCreated", self.onUnitCreated)
		eventManager.addEventHandler("unitLost", self.onUnitLost)
		
		
	def onWindowActivation(self, argsList):
		'Called when the game window activates or deactivates'
		bActive = argsList[0]

		#if (bActive):
			#


	def onUnitMove(self, argsList):
		'unit move'
		pPlot,pUnit = argsList
		pPlayer = gc.getPlayer(pUnit.getOwner())
		#pUnitInfo = gc.getUnitInfo(pUnit.getUnitType())
		#strUnitDesc = pUnitInfo.getDescription()

		dictTypeStats = CvJDataStorageUtils.getTypeStatsDict(pUnit, "InitialUnitTypes")
                xStat = CvJDataStorageUtils.getTypeStat(pUnit, "InitialUnitTypes", "iUnitType")

		JUtils.alertDebug(0, "dictTypeStats", dictTypeStats)
		JUtils.alertDebug(0, "xStat", xStat)

	def onUnitCreated(self, argsList):
		'Unit Completed'
		pUnit = argsList[0]
		iPlayer = pUnit.getOwner()
		pPlayer = gc.getPlayer(iPlayer)

		iUnitType = pUnit.getUnitType()
		iUnitCivType = pUnit.getCivilizationType()

		iTurnBuilt = gc.getGame().getGameTurn()
		iYearBuilt = gc.getGame().getGameTurnYear()

                if (not CvJDataStorageUtils.hasTypesDict(pUnit)):
                        CvJDataStorageUtils.initTypesDict(pUnit)

		CvJDataStorageUtils.initTypeStatsDict(pUnit, "InitialUnitTypes")
		CvJDataStorageUtils.setTypeStat(pUnit, "InitialUnitTypes", "iUnitType", iUnitType)
		CvJDataStorageUtils.setTypeStat(pUnit, "InitialUnitTypes", "iUnitCivType", iUnitCivType)
		CvJDataStorageUtils.setTypeStat(pUnit, "InitialUnitTypes", "iTurnBuilt", iTurnBuilt)
		CvJDataStorageUtils.setTypeStat(pUnit, "InitialUnitTypes", "iYearBuilt", iYearBuilt)


        def onUnitLost(self, argsList):
		'Unit Lost'
		pUnit = argsList[0]
		pPlayer = gc.getPlayer(pUnit.getOwner())

		CvJDataStorageUtils.delTypesDict(pUnit)











