#
# JUtils for Civ4
# by Jeckel
# 
# 

from CvPythonExtensions import *
import CvUtil

import sys
import time

###################################################
# globals

gc = CyGlobalContext()

############################################################################



###################################################################
# These methods produce messages in the log and/or on the screen. #
###################################################################
        
def logCombatMessage(ePlayer, szMessage):
        strMessage = str(szMessage)
        CyInterface().addCombatMessage(ePlayer, strMessage)

def alertDebug(iPlayer, message, value, iColor = 7):

        pPlayer = gc.getPlayer(iPlayer)

        # Return immediately if the player passed in is invalid
	if (pPlayer == None) or (pPlayer.isNone()) or (not pPlayer.isHuman()):
		return None

        eventMessageTimeLong = gc.getDefineINT("EVENT_MESSAGE_TIME_LONG")
        szIcon = None
        iFlashX = 0
        iFlashY = 0

        szString = str(message) + " = " + str(value)

        CyInterface().addMessage(iPlayer, True, eventMessageTimeLong,
                                 szString, None, 0, szIcon, ColorTypes(iColor),
                                 iFlashX, iFlashY, False, False)

def alert(iPlayer, message, iColor = 7):

        pPlayer = gc.getPlayer(iPlayer)

        # Return immediately if the player passed in is invalid
	if (pPlayer == None) or (pPlayer.isNone()) or (not pPlayer.isHuman()):
		return None

        eventMessageTimeLong = gc.getDefineINT("EVENT_MESSAGE_TIME_LONG")
        szIcon = None
        iFlashX = 0
        iFlashY = 0

        szString = str(message)

        CyInterface().addMessage(iPlayer, True, eventMessageTimeLong,
                                 szString, None, 0, szIcon, ColorTypes(iColor),
                                 iFlashX, iFlashY, False, False)

def alertIcon(iPlayer, message, pObject, szIcon = None, iColor = 7):

        pPlayer = gc.getPlayer(iPlayer)

        # Return immediately if the player passed in is invalid
	if (pPlayer == None) or (pPlayer.isNone()) or (not pPlayer.isHuman()):
		return None

        # Return immediately if the object passed in is invalid
	if (pObject == None) or (pObject.isNone()):
		return None

        eventMessageTimeLong = gc.getDefineINT("EVENT_MESSAGE_TIME_LONG")

        strMessage = str(message)

        CyInterface().addMessage(iPlayer, True, eventMessageTimeLong,
                                 strMessage, None, 0, szIcon, ColorTypes(iColor),
                                 pObject.getX(), pObject.getY(), True, True)

############################################################################

def getDiceRoll(iDiceRolls, iDieSides, iModRand=0, iMinRand=0, iMaxRand=-1, bTotalRolls=True):
        "Returns an int obj or a list obj"

        iDiceList = range(iDiceRolls)

        iRollTotal = 0
        iRollList = []
        for iDie in iDiceList:
                iRandRoll = CyGame().getSorenRandNum(iDieSides, "Random d%d Die Roll" %(iDieSides))
                iRoll = iRandRoll + 1
                iModRoll = iRoll + iModRand
                if (iModRoll < iMinRand) and (iMinRand >= 2):
                        iFinalRoll = iMinRand
                if (iModRoll > iMaxRand) and (iMaxRand >= 1):
                        iFinalRoll = iMaxRand
                iFinalRoll = iModRoll
                if (bTotalRolls):
                        iRollTotal += iFinalRoll
                        continue
                iRollList += [iFinalRoll]
                continue

        if (bTotalRolls):
                return iRollTotal
        return iRollList

############################################################################

def getDataIDStr(pObj=None):

        # Return is the unit is invalid
        if (pObj == None) or (pObj.isNone()):
                return "XXXXXXXX_XXXXXXXX"

        return str(pObj.getOwner()) + "_" + str(pObj.getID())

def getUniqueDataIDStr(pUnit=None):

        #iElapsedSecondsSince1970 = time.?

        # Return is the unit is invalid
        if (pUnit == None) or (pUnit.isNone()) or (pUnit.isDead()):
                return "XXXXXXXX_iElapsedSecondsSince1970_XXXXXXXX"

        return str(pUnit.getOwner()) + "_" + str(pUnit.getID())

############################################################################













